using namespace std;
#include "No.h"
#pragma once

/**
 * Não alterar este ficheiro
 */
 
// Classe Fila
class Fila{
    public:
    // Nos que apontam ao primeiro e ultimo nó da fila
    No *primeiro,*ultimo;
    
    // Contrutor de uma fila vazia
    Fila();
 
    // Insere o cliente c no final fila
    void insere(Cliente c);
    
    // Remove o cliente que está na frente da fila
    // Imprime "Fila vazia" se não existem clientes na fila
    void sai();
    
    // Imprime a fila
    // Deve imprimir "Fila vazia" - se não existem cliente na fila
    // Deve imprimir a fila no formato: "Inicio: Nome,Nº de rodutos; Nome, Nº; ... ;" 
    // Exemplo "Inicio: Maria,5; Pedro,10; Susana,20;"
    void imprime_fila();
    
    // Devolve o número de produtos que estão no total da fila (contando todos os clientes)
    int numeroProdutos();
    
    // Devolve o número de clientes que estão na fila
    int numeroClientes();
    
    // Devolve o nome do cliente que está na fila com maior numero de produtos
    // Se existirem clientes com igual número devem devolver o primeiro que encontram
    // Se fila estiver vazia devem devolver "Fila vazia"
    string clienteMaisProdutos();
    
    // Destrutor da fila
    ~Fila();
};